/* GTK Napster-0.201
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <unistd.h>

#include "common.h"
#include "nread.h"

void napster_something_to_read(gpointer data, gint source, GdkInputCondition condition)
{
	gint16 length = 0;
	gint16 code = 0;
	gint buffer_length = 0;
	gint read_length = 0;
	gchar buffer[4096];
	gchar length_code_buffer[4];
	gtk_sess *sess = (gtk_sess *)data;	
	gint lcreceived = 0;
	gint lcread = 0;
	
	while(lcreceived < 4)
	{
		if((lcread = recv(sess->sockfd, &length_code_buffer[lcreceived], 4-lcreceived, 0)) == -1)
		{
			perror("recv");
			gtk_message_ok(MSGBOX_ERROR_LENGTH_CODE, MSGBOX_ERROR_RECV_TITLE, DIALOG_ERROR);
			return;
		}
		lcreceived += lcread;
	}
	
	memcpy(&length, length_code_buffer, 2);
	memcpy(&code, &length_code_buffer[2], 2);
	
	if(length >= 4096)
	{
		g_warning(WARNING_HUGE_STRING, length);
		return;
	}
	
	while(length > buffer_length)
	{
		if((read_length = recv(sess->sockfd, &buffer[buffer_length], length-buffer_length, 0)) == -1)
		{
			perror("recv");
			gtk_message_ok(MSGBOX_ERROR_STRING, MSGBOX_ERROR_RECV_TITLE, DIALOG_ERROR);
			return;
		}
		buffer_length +=	read_length;	
	}
	buffer[buffer_length] = '\0';
	read_command_run(sess, code, buffer);
}

gint send_string(gtk_sess *sess, gchar *instr, gint16 code)
{
	gchar *msg;
	gint16 length = strlen(instr);
	gint sendt = 0;
	
	msg = (gchar *)g_malloc(length + 6);

	memcpy(msg, &length, 2);
	memcpy(&msg[2], &code, 2);
	strcpy(&msg[4], instr);
	
	if(sess->CONNECTED)
	{
		while(sendt < (length+4))
		{
			if((sendt += send(sess->sockfd, msg, length+4, 0)) == -1)
			{
				perror("send");
				g_free(msg);
				return FALSE;
			}
		}
	}
	else
	{
		gtk_message_ok(MSGBOX_NOT_CONNECTED, MSGBOX_ERROR_SEND_TITLE, DIALOG_WARNING);
		g_free(msg);
		return FALSE;
	}
	g_free(msg);
	return TRUE;
}

